4 USAGE='<fetch-options> <repository> <refspec>...'
7 set_reflog_action "fetch $*"
8 cd_to_toplevel ;# probably unnecessary...
11 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
12 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
28 test -t 1 || no_progress=--no-progress
33 -a|--a|--ap|--app|--appe|--appen|--append)
36 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
37 --upload-pa|--upload-pac|--upload-pack)
39 exec="--upload-pack=$1"
41 --upl=*|--uplo=*|--uploa=*|--upload=*|\
42 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
43 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
46 -f|--f|--fo|--for|--forc|--force)
49 -t|--t|--ta|--tag|--tags)
52 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
55 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
56 --update-he|--update-hea|--update-head|--update-head-|\
57 --update-head-o|--update-head-ok)
60 -q|--q|--qu|--qui|--quie|--quiet)
66 -k|--k|--ke|--kee|--keep)
70 shallow_depth="--depth=$(expr "z$1" : 'z-[^=]*=\(.*\)')"
74 shallow_depth="--depth=$1"
88 origin=$(get_default_remote)
89 test -n "$(get_remote_url ${origin})" ||
90 die "Where do you want to fetch from today?"
91 set x $origin ; shift ;;
96 # No command line override and we have configuration for the remote.
97 exec="--upload-pack=$(get_uploadpack $1)"
101 remote=$(get_remote_url "$@")
104 rsync_slurped_objects=
106 if test "" = "$append"
108 : >"$GIT_DIR/FETCH_HEAD"
111 # Global that is reused later
112 ls_remote_result=$(git ls-remote $exec "$remote") ||
113 die "Cannot get the repository state from $remote"
115 append_fetch_head () {
117 test -n "$verbose" && flags="$flags$LF-v"
118 test -n "$force$single_force" && flags="$flags$LF-f"
119 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
120 git fetch--tool $flags append-fetch-head "$@"
123 # updating the current HEAD with git-fetch in a bare
124 # repository is always fine.
125 if test -z "$update_head_ok" && test $(is_bare_repository) = false
127 orig_head=$(git rev-parse --verify HEAD 2>/dev/null)
130 # Allow --tags/--notags from remote.$1.tagopt
131 case "$tags$no_tags" in
133 case "$(git config --get "remote.$1.tagopt")" in
141 # If --tags (and later --heads or --all) is specified, then we are
142 # not talking about defaults stored in Pull: line of remotes or
143 # branches file, and just fetch those and refspecs explicitly given.
144 # Otherwise we do what we always did.
146 reflist=$(get_remote_refs_for_fetch "$@")
150 echo "$ls_remote_result" |
151 git show-ref --exclude-existing=refs/tags/ |
154 echo ".${name}:${name}"
158 # remote URL plus explicit refspecs; we need to merge them.
159 reflist="$reflist$LF$taglist"
161 # No explicit refspecs; fetch tags only.
166 fetch_all_at_once () {
168 eval=$(echo "$1" | git fetch--tool parse-reflist "-")
171 ( : subshell because we muck with IFS
174 if test "$remote" = . ; then
175 git show-ref $rref || echo failed "$remote"
176 elif test -f "$remote" ; then
177 test -n "$shallow_depth" &&
178 die "shallow clone with bundle is not supported"
179 git bundle unbundle "$remote" $rref ||
180 echo failed "$remote"
182 if test -d "$remote" &&
184 # The remote might be our alternate. With
185 # this optimization we will bypass fetch-pack
186 # altogether, which means we cannot be doing
187 # the shallow stuff at all.
188 test ! -f "$GIT_DIR/shallow" &&
189 test -z "$shallow_depth" &&
191 # See if all of what we are going to fetch are
192 # connected to our repository's tips, in which
193 # case we do not have to do any fetch.
194 theirs=$(echo "$ls_remote_result" | \
195 git fetch--tool -s pick-rref "$rref" "-") &&
197 # This will barf when $theirs reach an object that
198 # we do not have in our repository. Otherwise,
199 # we already have everything the fetch would bring in.
200 git rev-list --objects $theirs --not --all \
201 >/dev/null 2>/dev/null
203 echo "$ls_remote_result" | \
204 git fetch--tool pick-rref "$rref" "-"
212 git-fetch-pack --thin $exec $keep $shallow_depth \
213 $quiet $no_progress $flags "$remote" $rref ||
214 echo failed "$remote"
220 test -n "$verbose" && flags="$flags -v"
221 test -n "$force" && flags="$flags -f"
222 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
223 git fetch--tool $flags native-store \
224 "$remote" "$remote_nick" "$refs"
239 # These are relative path from $GIT_DIR, typically starting at refs/
241 if expr "z$ref" : 'z\.' >/dev/null
244 ref=$(expr "z$ref" : 'z\.\(.*\)')
248 if expr "z$ref" : 'z+' >/dev/null
251 ref=$(expr "z$ref" : 'z+\(.*\)')
255 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
256 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
258 rref="$rref$LF$remote_name"
260 # There are transports that can fetch only one head at a time...
262 http://* | https://* | ftp://*)
263 test -n "$shallow_depth" &&
264 die "shallow clone with http not supported"
265 proto=$(expr "$remote" : '\([^:]*\):')
266 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
269 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
270 "$(git config --bool http.noEPSV)" = true ]; then
271 noepsv_opt="--disable-epsv"
274 # Find $remote_name from ls-remote output.
275 head=$(echo "$ls_remote_result" | \
276 git fetch--tool -s pick-rref "$remote_name" "-")
277 expr "z$head" : "z$_x40\$" >/dev/null ||
278 die "No such ref $remote_name at $remote"
279 echo >&2 "Fetching $remote_name from $remote using $proto"
280 case "$quiet" in '') v=-v ;; *) v= ;; esac
281 git-http-fetch $v -a "$head" "$remote" || exit
284 test -n "$shallow_depth" &&
285 die "shallow clone with rsync not supported"
286 TMP_HEAD="$GIT_DIR/TMP_HEAD"
287 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
288 head=$(git rev-parse --verify TMP_HEAD)
290 case "$quiet" in '') v=-v ;; *) v= ;; esac
291 test "$rsync_slurped_objects" || {
292 rsync -a $v --ignore-existing --exclude info \
293 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
295 # Look at objects/info/alternates for rsync -- http will
296 # support it natively and git native ones will do it on
297 # the remote end. Not having that file is not a crime.
298 rsync -q "$remote/objects/info/alternates" \
299 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
300 rm -f "$GIT_DIR/TMP_ALT"
301 if test -f "$GIT_DIR/TMP_ALT"
303 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
306 case "$alt" in 'bad alternate: '*) die "$alt";; esac
307 echo >&2 "Getting alternate: $alt"
308 rsync -av --ignore-existing --exclude info \
309 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
311 rm -f "$GIT_DIR/TMP_ALT"
313 rsync_slurped_objects=t
318 append_fetch_head "$head" "$remote" \
319 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
327 http://* | https://* | ftp://* | rsync://* )
331 fetch_all_at_once "$@"
336 fetch_main "$reflist" || exit
338 # automated tag following
339 case "$no_tags$tags" in
343 # effective only when we are following remote branch
344 # using local tracking branch.
346 echo "$ls_remote_result" |
347 git show-ref --exclude-existing=refs/tags/ |
350 git cat-file -t "$sha1" >/dev/null 2>&1 || continue
351 echo >&2 "Auto-following $name"
352 echo ".${name}:${name}"
358 # do not deepen a shallow tree when following tags
360 fetch_main "$taglist" || exit ;;
364 # If the original head was empty (i.e. no "master" yet), or
365 # if we were told not to worry, we do not have to check.
370 curr_head=$(git rev-parse --verify HEAD 2>/dev/null)
371 if test "$curr_head" != "$orig_head"
374 -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
376 die "Cannot fetch into the current branch."